//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "updownclient.h"
#include "emule.h"
#include "UploadQueue.h"
#include "Clientlist.h"
#include "otherfunctions.h"
#include "IP2Country.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//	members of CUpDownClient
//	which are used by down and uploading functions

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef OLD_SOCKETS_ENABLED
CUpDownClient::CUpDownClient(CClientReqSocket *pRequestSocket) :
	m_pendingBlocksList(3), m_downloadBlocksList(3)
{
	m_pRequestSocket = pRequestSocket;
	m_pReqPartFile = NULL;
	Init();
}
#endif //OLD_SOCKETS_ENABLED
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CUpDownClient::CUpDownClient(uint16 uPort, uint32 dwClientID, uint32 dwServerIP, uint16 uServerPort, CPartFile *pReqPartFile) :
	m_pendingBlocksList(3), m_downloadBlocksList(3)
{
#ifdef OLD_SOCKETS_ENABLED
	m_pRequestSocket = NULL;
#endif //OLD_SOCKETS_ENABLED

	Init();

	SetUserID(dwClientID);
	m_uUserPort = uPort;
	m_iSourcesSlot = m_dwUserID % SOURCESSLOTS;
	if (!HasLowID())
	{
		m_strFullUserIP.Format( _T("%u.%u.%u.%u"),
								static_cast<byte>(m_dwUserID),
								static_cast<byte>(m_dwUserID >> 8),
								static_cast<byte>(m_dwUserID >> 16),
								static_cast<byte>(m_dwUserID >> 24) );
		m_dwConnectIP = m_dwUserID;
		m_uUserCountryIdx = g_eMuleApp.m_pIP2Country->GetCountryFromIP(m_dwConnectIP);
	}
	m_dwServerIP = dwServerIP;
	m_uServerPort = uServerPort;
	m_pReqPartFile = pReqPartFile;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::Init()
{
	EMULE_TRY

	m_strFullUserIP.Empty();
	m_pCredits = 0;
	m_dwEnteredConnectedState = 0;
	m_uLastPartAsked = 0xFFFF;
	m_dwClientSumDLDataRateOverLastNMeasurements = 0;
	m_dwClientSumDLTickOverLastNMeasurements = 0;
	m_dwTransferredInLastPeriod = 0;
	m_bLimitlessDL = true;
	m_uUDPPort = 0;
	m_byteFailedCount = 0;
	m_dwBanTime = 0;
	m_dwTransferredUp = 0;
	m_dwAskedCount = 0;
	m_dwDownAskedCount = 0;
	m_lUpDataRate = -1;
	m_strUserName.Empty();
	m_uUserCountryIdx = NO_COUNTRY_INFO;
	m_dwUserIP = 0;
	m_dwConnectIP = 0;
	SetUserID(0);
	m_uServerPort = 0;
	m_bIsOnLan = false;
	m_bBanned = false;
	m_iFileListRequested = m_iFileListRequestedSave = 0;
	m_dwLastUpRequest = 0;
	m_bEmuleProtocol = false;
	m_bCompleteSource = false;
	m_bCommentDirty = false;
	m_bReaskPending = false;
	m_bUDPPending = false;
	m_byteEmuleVersion = 0;
	m_dwClientVersion = 0;
	m_strModString.Empty();
	m_strClientSoft = _T("???");
	m_uUserPort = 0;
	m_uPartCount = 0;
	m_uUpPartCount = 0;
	m_pbytePartStatuses = NULL;
	m_pbyteUpPartStatuses = 0;
	m_dwLastAskedTime = 0;
	m_eDownloadState = DS_NONE;
	m_dwUploadTime = 0;
	m_dwTransferredDown = 0;
	m_dwDownDataRate = 0;
	m_byteFailedFileRequestsCount = 0;
	m_eUploadState = US_NONE;
	m_dwLastBlockReceived = 0;
	m_byteDataCompVer = 0;
	m_dwPlusVers = 0;
	m_byteUDPVer = 0;
	m_byteSourceExchangeVer = 0;
	m_byteAcceptCommentVer = 0;
	m_byteExtendedRequestsVer = 0;
	m_uRemoteQueueRank = 0;
	m_dwLastSourceRequest = 0;
	m_dwLastSourceAnswer = 0;
	m_byteCompatibleClient = 0;
	m_bIsHybrid = false;
	m_eChatState = MS_NONE;
	m_dwAwayMessageResendCount = 0;
	m_bIsML = false;
	m_pFriend = NULL;
	m_eRating = PF_RATING_NONE;
	m_strComment.Empty();
	m_dwLastGotULDataTime = 0;
	m_eClientSoft = SO_UNKNOWN;
	m_bRemoteQueueFull = false;
	md4clr(m_userHash);
	SetWaitStartTime();
	m_fRequestingHashSet = 0;
	m_fNoViewSharedFiles = 0;
	m_fSupportsAskSharedDirs = 0;
	m_fNoDataForRemoteClient = 1;

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket != NULL)
	{
		SOCKADDR_IN		sockAddr;

		memzero(&sockAddr, sizeof(sockAddr));

		int		iSockAddrLen = sizeof(sockAddr);

		m_pRequestSocket->GetPeerName(reinterpret_cast<SOCKADDR*>(&sockAddr),&iSockAddrLen);
		m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
		m_strFullUserIP = inet_ntoa(sockAddr.sin_addr);
		m_dwConnectIP = m_dwUserIP;
		m_uUserCountryIdx = g_eMuleApp.m_pIP2Country->GetCountryFromIP(m_dwConnectIP);
	}
#endif //OLD_SOCKETS_ENABLED
	m_iSourcesSlot = 0;
	m_uUpCompleteSourcesCount = 0;
	m_dwUpCompleteSourcesTime = 0;
	md4clr(m_reqFileHash);

	m_dwLastL2HACExec = 0;
	m_dwL2HACTime = 0;
	m_bL2HACEnabled = false;

	m_eSecureIdentState = IS_UNAVAILABLE;
	m_dwLastSignatureIP = 0;
	m_byteSupportSecIdent = 0;
	m_eInfoPacketsReceived = IP_NONE;

	m_byteActionsOnNameChange = 0;
	m_bHasUserNameForbiddenStrings = false;
	m_bIsMODNameChanged = false;
	m_bHasMODNameForbiddenStrings = false;
	m_bIsCommunity = false;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CUpDownClient::~CUpDownClient()
{
	EMULE_TRY

	g_eMuleApp.m_pDownloadList->RemoveSource(this);
	g_eMuleApp.m_pClientList->RemoveClient(this);

	if (m_pFriend != NULL)
		m_pFriend->SetLinkedClient(NULL);

#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pListenSocket->DeleteSocket(m_pRequestSocket);
#endif //OLD_SOCKETS_ENABLED
	if (m_pbytePartStatuses != NULL)
	{
		delete[] m_pbytePartStatuses;
		m_pbytePartStatuses	= NULL;
	}
	if (m_pbyteUpPartStatuses != NULL)
	{
		delete[] m_pbyteUpPartStatuses;
		m_pbyteUpPartStatuses = NULL;
	}
	ClearUploadBlockRequests();

	while (!m_requestedFilesList.IsEmpty())
	{
		delete m_requestedFilesList.RemoveHead();
	}

	ClearDownloadBlocksList();
	ClearPendingBlocksList();

	if (m_eRating != PF_RATING_NONE || m_strComment.GetLength() > 0)
	{
		m_eRating = PF_RATING_NONE;
		m_strComment.Empty();
		m_pReqPartFile->UpdateFileRatingCommentAvail();
	}

	m_averageUDRList.clear();
#ifdef OLD_SOCKETS_ENABLED

	DEBUG_ONLY (g_eMuleApp.m_pListenSocket->Debug_ClientDeleted(this));
#endif //OLD_SOCKETS_ENABLED
	SetUploadFileID(NULL);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ClearHelloProperties()
{
	m_uUDPPort = 0;
	m_byteUDPVer = 0;
	m_byteDataCompVer = 0;
	m_byteEmuleVersion = 0;
	m_byteSourceExchangeVer = 0;
	m_byteAcceptCommentVer = 0;
	m_byteExtendedRequestsVer = 0;
	m_byteCompatibleClient = 0;
	m_byteSupportSecIdent = 0;
	m_dwClientVersion = 0;
	m_fSupportsAskSharedDirs = 0;
	m_dwPlusVers = 0;
	m_dwL2HACTime = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::ProcessHelloPacket(BYTE *pbytePacket, uint32 dwSize)
{
	CSafeMemFile	packetStream(pbytePacket, dwSize);
	byte			byteHashSize;

	packetStream.Read(&byteHashSize, 1);
//	Reset all client properties; a client may not send a particular emule tag any longer
	ClearHelloProperties();
	return ProcessHelloTypePacket(packetStream);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessHelloAnswer(char* pbytePacket, uint32 dwSize)
{
	EMULE_TRY
	CSafeMemFile packetStream((BYTE*)pbytePacket, dwSize);
	ProcessHelloTypePacket(packetStream);
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::ProcessHelloTypePacket(CSafeMemFile &packetStream)
{
	m_bIsHybrid = false;
	m_bIsML = false;
	m_fNoViewSharedFiles = 0;

	packetStream.Read(&m_userHash, 16);

	uint32	dwUserID, dwTagCount, dwEmuleTags = 0;
	uint16	uUserPort;

	packetStream.Read(&dwUserID, 4);

	if (m_dwUserID == 0)
		SetUserID(dwUserID);

	packetStream.Read(&uUserPort, 2);
	packetStream.Read(&dwTagCount, 4);

	bool	bCrashed = false, bPrTag = false;

	for (uint32 i = 0; i < dwTagCount; i++)
	{
		CTag	TempTag;

		TempTag.FillFromStream(packetStream);
		switch (TempTag.GetTagID())
		{
			case CT_NAME:
				if (TempTag.IsStr())
				{
					if (!TempTag.IsStringValueEmpty())
					{
						if (!TempTag.IsStringValueEqual(m_strUserName))
						{
							TempTag.GetStringValue(&m_strUserName);
							m_byteActionsOnNameChange |= AONC_FORBIDDEN_NAME_CHECK | AONC_COMMUNITY_CHECK;
						}
						break;
					}
				}
				bCrashed = true;
				m_strUserName = _T("[Invalid user name]");
				break;

			case CT_VERSION:
				if (TempTag.IsInt())
					m_dwClientVersion = TempTag.GetIntValue();
				break;

			case CT_PORT:
				if (TempTag.IsInt())
					uUserPort = TempTag.GetIntValue();
				break;

			case CT_MOD_VERSION:
				if (TempTag.IsStr())
				{
					if (!TempTag.IsStringValueEqual(m_strModString))
					{
						TempTag.GetStringValue(&m_strModString);
						m_bIsMODNameChanged = true;
					}
				}
				else if (TempTag.IsInt())
					m_strModString.Format(_T("ModID=%u"), TempTag.GetIntValue());
				else
					m_strModString = _T("ModID=<Unknwon>");
				break;

			case CT_EMULE_UDPPORTS:
				// 16 KAD Port
				// 16 UDP Port
				if (TempTag.IsInt())
				{
					m_uUDPPort = static_cast<uint16>(TempTag.GetIntValue());
					dwEmuleTags |= 1;
				}
				break;

			case CT_EMULE_MISCOPTIONS1:
				//  3 AICH Version (0 = not supported)
				//  1 Unicode
				//  4 UDP version
				//  4 Data compression version
				//  4 Secure Ident
				//  4 Source Exchange
				//  4 Ext. Requests
				//  4 Comments
				//	1 PeerChache supported
				//	1 No 'View Shared Files' supported
				//	1 MultiPacket
				//  1 Preview
				if (TempTag.IsInt())
				{
					uint32	dwOpt = TempTag.GetIntValue();

					dwOpt >>= 2;	//skip Preview & MultiPacket
					m_fNoViewSharedFiles = dwOpt & 0x01;
					dwOpt >>= 1;
					dwOpt >>= 1;	//skip PeerChache
					m_byteAcceptCommentVer = dwOpt & 0x0F;
					dwOpt >>= 4;
					m_byteExtendedRequestsVer = dwOpt & 0x0F;
					dwOpt >>= 4;
					m_byteSourceExchangeVer = dwOpt & 0x0F;
					dwOpt >>= 4;
					m_byteSupportSecIdent = dwOpt & 0x0F;
					dwOpt >>= 4;
					m_byteDataCompVer = dwOpt & 0x0F;
					dwOpt >>= 4;
					m_byteUDPVer = dwOpt & 0x0F;
					dwOpt >>= 4;

					dwEmuleTags |= 2;
				}
				break;

			case CT_EMULE_MISCOPTIONS2:
				//	28 Reserved
				//   4 Kad Version
//				dwEmuleTags |= 8;
				break;

			case CT_EMULE_VERSION:
				//  8 Compatible Client ID
				//  7 Maj Version
				//  7 Min Version
				//  3 Upd Version
				//  7 Bld Version
				if (TempTag.IsInt())
				{
					m_dwClientVersion = TempTag.GetIntValue();
					m_byteCompatibleClient = (m_dwClientVersion >> 24);
					m_dwClientVersion &= 0x00FFFFFF;
					m_byteEmuleVersion = 0x99;
					m_fSupportsAskSharedDirs = 1;
					dwEmuleTags |= 4;
				}
				break;

			default:
			//	Since eDonkeyHybrid 1.3 is no longer sending the additional Int32
			//	at the end of the Hello packet, we use the "pr=1" tag to determine them
				if ((TempTag.GetTagName() != NULL) && (TempTag.GetTagName()[0] == 'p') && (TempTag.GetTagName()[1] == 'r'))
					bPrTag = true;
		}
	}
	m_uUserPort = uUserPort;

//	Check the other client's server parameters and add it to our server list
	packetStream.Read(&m_dwServerIP, 4);
	packetStream.Read(&m_uServerPort, 2);
//	If the client didn't try to crash us with a blank name and the "add servers to server list on connect" preference is on...
	if (!bCrashed && g_eMuleApp.m_pGlobPrefs->GetAddServersFromConn())
	{
	//	... and server IP and port are valid (fast check) and the server isn't already in our server list
		if ((m_dwServerIP != 0) && (m_uServerPort != 0) && !g_eMuleApp.m_pServerList->GetServerByIP(m_dwServerIP, m_uServerPort))
		{
			in_addr		addhost;

			addhost.S_un.S_addr = m_dwServerIP;

			CServer		*pServer = new CServer(m_uServerPort, CString(inet_ntoa(addhost)));

			pServer->SetListName(pServer->GetAddress());
			if (!g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.AddServer(pServer, true))
				delete pServer;
		}
	}

// Check for additional data in Hello packet to determine client's software
// - eDonkeyHybrid 0.40 - 1.2 sends an additional Int32 (since 1.3 they don't send it anymore)
// - MLdonkey sends an additional Int32
	if (packetStream.GetLength() - packetStream.GetPosition() == 4)
	{
		uint32		dwTest;

		packetStream.Read(&dwTest, 4);
		if (dwTest == 'KDLM')
		{
			m_bIsML = true;
		}
		else
			m_bIsHybrid = true;
	}

	SOCKADDR_IN		sockAddr;

	memzero(&sockAddr, sizeof(sockAddr));

	uint32			dwSockAddrLen = sizeof(sockAddr);

#ifdef OLD_SOCKETS_ENABLED
	m_pRequestSocket->GetPeerName((SOCKADDR*) &sockAddr, (int*) &dwSockAddrLen);
#endif //OLD_SOCKETS_ENABLED

	m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
	m_strFullUserIP = inet_ntoa(sockAddr.sin_addr);
	if (m_dwConnectIP != m_dwUserIP)
	{
		m_dwConnectIP = m_dwUserIP;
		m_uUserCountryIdx = g_eMuleApp.m_pIP2Country->GetCountryFromIP(m_dwConnectIP);
	}

//	If Lancast is enabled check to see if this client is on the LAN
	m_bIsOnLan = ((g_eMuleApp.m_pGlobPrefs->GetLancastEnabled()) && ((g_eMuleApp.m_pGlobPrefs->GetLancastIP() & g_eMuleApp.m_pGlobPrefs->GetLancastSubnet()) == (m_dwUserIP & g_eMuleApp.m_pGlobPrefs->GetLancastSubnet())));
	if (m_bIsOnLan)
		m_dwUserID = m_dwUserIP;

//	Make sure if this user is a HighID user his userID matches his IP address
	if (!HasLowID() && m_dwUserID != m_dwUserIP)
		SetUserID(m_dwUserIP);

//	Get client credits
	uchar key[16];
	md4cpy(key, m_userHash);
	m_pCredits = g_eMuleApp.m_pClientCreditList->GetCredit(key);

	if ((m_pFriend = g_eMuleApp.m_pFriendList->SearchFriend(key, m_dwUserIP, m_uUserPort)) != NULL)
	{
	//	Link the friend to that client
		m_pFriend->SetLinkedClient(this);

		if (m_eChatState == MS_CONNECTING)
		{
			TCITEM		tcNewItem;

			tcNewItem.mask = TCIF_TEXT;
			tcNewItem.pszText = m_strUserName.GetBuffer(256);
			g_eMuleApp.m_pdlgEmule->m_wndChat.m_ctlChatSelector.SetItem(g_eMuleApp.m_pdlgEmule->m_wndChat.m_ctlChatSelector.GetTabByClient(this), &tcNewItem);
		}
	}
//	Check if at least CT_EMULEVERSION was received, all other tags are optional
	bool bIsMule = ((dwEmuleTags & 0x04) != 0);

	if (!bIsMule && bPrTag)
		m_bIsHybrid = true;
	if (m_bIsHybrid)
		m_fSupportsAskSharedDirs = 1;

	ReGetClientSoft();

//--- xrmb:hashthieves1 ---
//--- detectmystolenhash ---
//	Get IP-Port hash
	const uint64 qwIPPortID = GetUID();
	uint32 dwNewUnfairActions = 0;
	uint32 dwUnfairClientActions = 0;
	OffenseCounterMap::iterator OffenseCounterIt = g_eMuleApp.m_pClientList->m_mapOffenseCounter.find(qwIPPortID);

	if (OffenseCounterIt != g_eMuleApp.m_pClientList->m_mapOffenseCounter.end())
	{
		dwUnfairClientActions = OffenseCounterIt->second;
	}

#ifdef OLD_SOCKETS_ENABLED
//	Check if remote client has our HASH
	if (g_eMuleApp.m_pServerConnect->GetClientID() != m_dwUserID
		&& md4cmp(m_userHash, g_eMuleApp.m_pGlobPrefs->GetUserHash()) == 0
		&& g_eMuleApp.m_pGlobPrefs->IsCounterMeasures())
	{
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_HASHIMP));
		dwNewUnfairActions++;
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumUnfairActions);
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumUseMyHashActions);
	}
#endif //OLD_SOCKETS_ENABLED

//	Detect a hash chager (detect id-changer). Actually we are detecting a change of ID based on UserHash
	uint64 qwNewHashID = 0;
	uint32 *pdwHash = reinterpret_cast<uint32*>(GetUserHash());

//	Calculate a HASH-ID
	qwNewHashID = (static_cast<uint64>(pdwHash[1] ^ pdwHash[3]) << static_cast<uint64>(32)) |
		static_cast<uint64>(pdwHash[0] ^ pdwHash[2]);

//	Check a map
	HashBaseMap::iterator HashBaseIt = g_eMuleApp.m_pClientList->m_mapHashBase.find(qwIPPortID);

	if (HashBaseIt != g_eMuleApp.m_pClientList->m_mapHashBase.end())
	{
		if (HashBaseIt->second != qwNewHashID)
		{
			dwNewUnfairActions++;
			InterlockedIncrement(&g_eMuleApp.m_lTotalNumUnfairActions);
			InterlockedIncrement(&g_eMuleApp.m_lTotalNumHashChangeActions);
		}
	}
//	Update a IDhash
	 g_eMuleApp.m_pClientList->m_mapHashBase[qwIPPortID] = qwNewHashID;

//	Check famous stolen hashs/names
	if (HasUserNameForbiddenStrings())
	{
		dwNewUnfairActions++;
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumUnfairActions);
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumStolenNameActions);
	}

	if ((dwUnfairClientActions + dwNewUnfairActions) >= 3
		&& g_eMuleApp.m_pGlobPrefs->IsCounterMeasures())
	{
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_HASHSTEAL));
	}

//	If we found new unfair action from remote client, then update table
	if (dwNewUnfairActions != 0)
	{
		g_eMuleApp.m_pClientList->m_mapOffenseCounter[qwIPPortID] = dwUnfairClientActions + dwNewUnfairActions;
		g_eMuleApp.m_lTotalNumUnfairClients = g_eMuleApp.m_pClientList->m_mapOffenseCounter.size();
	}
//--- :xrmb ---

	m_eInfoPacketsReceived |= IP_EDONKEYPROTPACK;
	if (bIsMule)
	{
		m_bEmuleProtocol = true;
		m_eInfoPacketsReceived |= IP_EMULEPROTPACK;
	}

	return bIsMule;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendHelloPacket()
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
//	If IP is filtered, don't greet him but disconnect...
	if (m_pRequestSocket != NULL)
	{
		SOCKADDR_IN	sockAddr;

		memzero(&sockAddr, sizeof(sockAddr));

		uint32		dwSockAddrLen = sizeof(sockAddr);

		m_pRequestSocket->GetPeerName(reinterpret_cast<SOCKADDR*>(&sockAddr), reinterpret_cast<int*>(&dwSockAddrLen));

		CMemFile	packetStream(128);
		byte		byteHashSize = 16;

		packetStream.Write(&byteHashSize, 1);
		SendHelloTypePacket(packetStream);

		Packet		*pPacket = new Packet(&packetStream);

		pPacket->m_eOpcode = OP_HELLO;
		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
		m_pRequestSocket->SendPacket(pPacket, true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendMuleInfoPacket(bool bAnswer)
{
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket)
	{
		CMemFile packetStream(128);
	//	Header of the info packet
		byte uClientVersion = CURRENT_VERSION_SHORT;
		packetStream.Write(&uClientVersion, 1);
		byte uProtVersion = EMULE_PROTOCOL;
		packetStream.Write(&uProtVersion, 1);

		CWrTag	tagWr;
		uint32	dwTagCount = 10;

		packetStream.Write(&dwTagCount, 4);
	//	Body of the info packet
		tagWr.WriteToFile(ET_COMPRESSION, 1, packetStream);
		tagWr.WriteToFile(ET_UDPVER, 4, packetStream);
		tagWr.WriteToFile(ET_UDPPORT, g_eMuleApp.m_pGlobPrefs->GetUDPPort(), packetStream);
		tagWr.WriteToFile(ET_SOURCEEXCHANGE, 2, packetStream);
		tagWr.WriteToFile(ET_COMMENTS, 1, packetStream);
		tagWr.WriteToFile(ET_MOD_PLUS, CURRENT_PLUS_VERSION, packetStream);
		tagWr.WriteToFile(ET_EXTENDEDREQUEST, 2, packetStream);
		tagWr.WriteToFile(ET_MOD_VERSION, _T(PLUS_VERSION_STR), packetStream);
		tagWr.WriteToFile(ET_L2HAC, FILEREASKTIME, packetStream);
		tagWr.WriteToFile(ET_FEATURES, (uint32)(g_eMuleApp.m_pClientCreditList->CryptoAvailable() ? 3 : 0), packetStream);

		Packet		*pPacket = new Packet(&packetStream, OP_EMULEPROT);
		if (!bAnswer)
			pPacket->m_eOpcode = OP_EMULEINFO;
		else
			pPacket->m_eOpcode = OP_EMULEINFOANSWER;

		if (m_pRequestSocket != NULL)
		{
			g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
			m_pRequestSocket->SendPacket(pPacket, true, true);
		}
		else
		{
			delete pPacket;
		}
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}

void CUpDownClient::ProcessMuleInfoPacket(BYTE* pbytePacket, uint32 dwSize)
{
	EMULE_TRY

	CSafeMemFile packetStream(pbytePacket, dwSize);
	m_byteCompatibleClient = 0;

	byte	byteEmuleVer, byteEmuleProt;

	packetStream.Read(&byteEmuleVer, 1);
	if (byteEmuleVer == 0x2B)
		byteEmuleVer = 0x22;

	packetStream.Read(&byteEmuleProt, 1);

//	Implicitly supported options by older clients
	if (byteEmuleProt != EMULE_PROTOCOL)
		return;
	if (m_byteEmuleVersion != 0x99)	//CT_EMULE_VERSION wasn't received
		m_byteEmuleVersion = byteEmuleVer;
	else
	{
	//	Make version again in the CT_EMULE_VERSION style
		m_dwClientVersion = (GET_CLIENT_MAJVER(m_dwClientVersion) << 17) |
			(GET_CLIENT_MINVER(m_dwClientVersion) << 10) | (GET_CLIENT_UDPVER(m_dwClientVersion) << 7);
	}

//	In the future do not use version to guess about new features
	if (m_byteEmuleVersion < 0x25 && m_byteEmuleVersion > 0x22)
		m_byteUDPVer = 1;

	if (m_byteEmuleVersion < 0x25 && m_byteEmuleVersion > 0x21)
		m_byteSourceExchangeVer = 1;

	if (m_byteEmuleVersion == 0x24)
		m_byteAcceptCommentVer = 1;

//	Shared directories are requested since eMule 0.28+ because eMule 0.27 has a bug in
//	the OP_ASKSHAREDFILESDIR handler, which does not return the shared files for a directory
//	which has a trailing backslash. MLdonkey currently does not support shared directories
//	eMule+ supports shared directories since 1h (0x0108) -- eMule+ is checked later after detection
	if ((m_byteEmuleVersion >= 0x28) && !m_bIsML)
		m_fSupportsAskSharedDirs = 1;

	m_bEmuleProtocol = true;
	m_dwL2HACTime = 0;

	uint32 i, dwTagCount;
	packetStream.Read(&dwTagCount, 4);

	try
	{
		for (i = 0; i < dwTagCount; i++)
		{
			CTag	TempTag;

			TempTag.FillFromStream(packetStream);
			switch (TempTag.GetTagID())
			{
				case ET_COMPRESSION:
					if (TempTag.IsInt())
						m_byteDataCompVer = TempTag.GetIntValue();
					break;

				case ET_UDPPORT:
					if (TempTag.IsInt())
						m_uUDPPort = TempTag.GetIntValue();
					break;

				case ET_UDPVER:
					if (TempTag.IsInt())
						m_byteUDPVer = TempTag.GetIntValue();
					break;

				case ET_SOURCEEXCHANGE:
					if (TempTag.IsInt())
						m_byteSourceExchangeVer = TempTag.GetIntValue();
					break;

				case ET_COMMENTS:
					if (TempTag.IsInt())
						m_byteAcceptCommentVer = TempTag.GetIntValue();
					break;

				case ET_EXTENDEDREQUEST:
					if (TempTag.IsInt())
						m_byteExtendedRequestsVer = TempTag.GetIntValue();
					break;

				case ET_COMPATIBLECLIENT:
				//	Bits 31- 8: 0 - reserved
				//	Bits  7- 0: compatible client ID
					if (TempTag.IsInt())
						m_byteCompatibleClient = TempTag.GetIntValue();
					break;

				case ET_MOD_VERSION:
					if (TempTag.IsStr())
					{
						if (!TempTag.IsStringValueEqual(m_strModString))
						{
							TempTag.GetStringValue(&m_strModString);
							m_bIsMODNameChanged = true;
						}
					}
					else if (TempTag.IsInt())
						m_strModString.Format(_T("ModID=%u"), TempTag.GetIntValue());
					else
						m_strModString = _T("ModID=<Unknwon>");
					break;

				case ET_MOD_PLUS:
					if (TempTag.IsInt())
						m_dwPlusVers = TempTag.GetIntValue();
					break;

				case ET_L2HAC:
					if (TempTag.IsInt())
						m_dwL2HACTime = TempTag.GetIntValue();
					break;

				case ET_FEATURES:
				//	Bits 31- 8: 0 - reserved
				//	Bit      7: Preview
				//	Bit   6- 0: secure identification
					if (TempTag.IsInt())
						m_byteSupportSecIdent = TempTag.GetIntValue() & 3;
					break;
			}
		}
	}
	catch (CException *error)
	{
		error->Delete();
#ifdef _DEBUG
		AddDebugLogLine( _T("Error while processing emuletag %u/%u from client %s %s:%u"), i + 1,
						 dwTagCount, GetClientNameWithSoftware(), GetFullIP(), GetUserPort() );
#endif
	}

	if (!m_dwL2HACTime)
		m_dwL2HACTime = L2HAC_DEFAULT_EMULE;
	if (m_dwL2HACTime < L2HAC_MIN_TIME || m_dwL2HACTime > L2HAC_MAX_TIME)
		m_dwL2HACTime = 0;

	if (m_byteDataCompVer == 0)
	{
		m_byteSourceExchangeVer = 0;
		m_byteExtendedRequestsVer = 0;
		m_byteAcceptCommentVer = 0;
		m_uUDPPort = 0;
		m_dwL2HACTime = 0;
	}

//	Validate eMule Plus version

//	Check minimal existing version and the last version sending ET_MOD_PLUS
	if ((m_dwPlusVers > 0x111) || (m_dwPlusVers < 0x100))
		m_dwPlusVers = 0;
	if (m_dwPlusVers != 0)
	{
		if ( ((m_dwPlusVers != CURRENT_PLUS_VERSION) && (m_strModString.Compare(_T(PLUS_VERSION_STR)) == 0)) ||
			((m_dwPlusVers <= 0x103) && (m_byteEmuleVersion > 0x26)) ||
			((m_dwPlusVers > 0x103) && m_strModString.IsEmpty()) ||	//several old versions didn't have ModString
			(m_strModString.GetLength() > 10) ||
			( (m_strModString.GetLength() >= 5) &&
			(memcmp(m_strModString.GetString(), _T("Plus "), sizeof(_T("Plus ")) - sizeof(TCHAR)) != 0) &&
			(memcmp(m_strModString.GetString(), _T("koizo"), sizeof(_T("koizo")) - sizeof(TCHAR)) != 0) ) )
		{
			m_dwPlusVers = 0;
		}
	}

//	eMule+ supports shared directories since 1h (0x0108)
	if ((m_dwPlusVers != 0) && (m_dwPlusVers < 0x0108))
		m_fSupportsAskSharedDirs = 0;

	ReGetClientSoft();

//	Reset version if client type is incorrect (here SO_UNKNOWN means that handshaking hasn't finished yet)
	if ((m_dwPlusVers != 0) && (m_eClientSoft != SO_PLUS) && (m_eClientSoft != SO_UNKNOWN))
		m_dwPlusVers = 0;

	m_eInfoPacketsReceived |= IP_EMULEPROTPACK;

//	eMule Plus supports 'complete sources' since version 1f (force ET_EXTENDEDREQUEST v2 for backward compatibility)
	if ((GetPlusVersion() < 0x0108) && (GetPlusVersion() >= 0x0106) && (GetExtendedRequestsVersion() == 1))
		m_byteExtendedRequestsVer = 2;

//	Check leecher clients
	if ( HasMODNameForbiddenStrings() || ( (GetModString() == _T(PLUS_VERSION_STR)) &&
		(m_dwPlusVers == 0) ) )
	{
		const uint64 qwIPPortID = GetUID();
		uint32 dwUnfairClientActions = 0;
		OffenseCounterMap::iterator OffenseCounterIt = g_eMuleApp.m_pClientList->m_mapOffenseCounter.find(qwIPPortID);

		if (OffenseCounterIt != g_eMuleApp.m_pClientList->m_mapOffenseCounter.end())
		{
			dwUnfairClientActions = OffenseCounterIt->second;
		}
		dwUnfairClientActions++;
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumUnfairActions);
		InterlockedIncrement(&g_eMuleApp.m_lTotalNumLeecherTypeActions);
		g_eMuleApp.m_pClientList->m_mapOffenseCounter[qwIPPortID] = dwUnfairClientActions;
		g_eMuleApp.m_lTotalNumUnfairClients = g_eMuleApp.m_pClientList->m_mapOffenseCounter.size();
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_LEECHERADV));
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendHelloAnswer()
{
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket != NULL)
	{
		CMemFile packetStream(128);
		SendHelloTypePacket(packetStream);
		Packet		*pPacket = new Packet(&packetStream);
		pPacket->m_eOpcode = OP_HELLOANSWER;
		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
		m_pRequestSocket->SendPacket(pPacket, true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendHelloTypePacket(CMemFile &packetStream)
{
	EMULE_TRY

	BYTE		hash[16];
	CWrTag		tagWr;

	md4cpy(hash, g_eMuleApp.m_pGlobPrefs->GetUserHash());

//	Checking for MLDonkey does not help against their unfair share policy anymore
//	since they have removed this feature so we emulate now an eDonkey to MLDonkey.

//	If we can see that the client is MLDonkey and MLDonkey countermeasures are turned on...
	if (GetClientSoft() == SO_MLDONKEY && g_eMuleApp.m_pGlobPrefs->IsCounterMeasures())
	{
	//	Spoof the identifying bytes in the hash with random values.
		do
		{
			uint32 dwRnd = rand();

			hash[5] = static_cast<BYTE>(dwRnd);
			hash[14] = static_cast<BYTE>(dwRnd >> 8);
		} while ((hash[5] == 14) || (hash[14] == 111));
	}
	packetStream.Write(hash, 16);					// <userhash 16>

#ifdef OLD_SOCKETS_ENABLED
	uint32		dwClientID = g_eMuleApp.m_pServerConnect->GetClientID();

	packetStream.Write(&dwClientID, 4);				// <ourclientid 4>
#endif //OLD_SOCKETS_ENABLED

	uint16		nPort = g_eMuleApp.m_pGlobPrefs->GetListenPort();

	packetStream.Write(&nPort, 2);					// <ourport 2>

	uint32		dwTagCount = 5;

	packetStream.Write(&dwTagCount, 4);				// <tagcount 4>

	g_eMuleApp.m_pGlobPrefs->WritePreparedNameTag(packetStream);		// { NAME : int }
	tagWr.WriteToFile(CT_VERSION, EDONKEYVERSION, packetStream);		// { VERSION : int }
	tagWr.WriteToFile(CT_EMULE_UDPPORTS, g_eMuleApp.m_pGlobPrefs->GetUDPPort(), packetStream);

//	eMule Misc. Options #1
	const uint32	dwSupportSecIdent = (g_eMuleApp.m_pClientCreditList->CryptoAvailable() ? 3 : 0);
	const uint32	dwNoViewSharedFiles = ((g_eMuleApp.m_pGlobPrefs->CanSeeShares() == SEE_SHARE_NOONE) ? 1 : 0); // for backward compatibility this has to be a 'negative' flag
	tagWr.WriteToFile( CT_EMULE_MISCOPTIONS1,
		(4						<< 4*6) |	//UDP version
		(1						<< 4*5) |	//Data compression version
		(dwSupportSecIdent		<< 4*4) |	//Secure Ident
		(2						<< 4*3) |	//Source Exchange
		(2						<< 4*2) |	//Ext. Requests
		(1						<< 4*1) |	//Comments
		(dwNoViewSharedFiles	<< 1*2), packetStream );	//No 'View Shared Files' supported

#if ((CURRENT_PLUS_VERSION & 0xF) > 7)
#error Incompatible eMule Plus version build number is used
#endif
	tagWr.WriteToFile( CT_EMULE_VERSION, (PLUS_COMPATIBLECLIENTID << 24) | ((CURRENT_PLUS_VERSION & 0x7F00) << 9) |
		((CURRENT_PLUS_VERSION & 0xF0) << 6) | ((CURRENT_PLUS_VERSION & 0x7) << 7), packetStream );

	uint32		dwIP = 0;

	nPort = 0;
#ifdef OLD_SOCKETS_ENABLED

	if (g_eMuleApp.m_pServerConnect->IsConnected())
	{
		CServer	*pCurServer = g_eMuleApp.m_pServerConnect->GetCurrentServer();

		dwIP = pCurServer->GetIP();
		nPort = pCurServer->GetPort();
	}
#endif //OLD_SOCKETS_ENABLED
	packetStream.Write(&dwIP, 4);					// <serverip 4>
	packetStream.Write(&nPort, 2);					// <serverport 2>
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessMuleCommentPacket(char* pachPacket, uint32 dwSize)
{
	EMULE_TRY

	if ((m_pReqPartFile != NULL) && ((dwSize > (sizeof(m_eRating) + sizeof(int) - 1))))
	{
		CSafeMemFile packetStream((BYTE*)pachPacket, dwSize);
		int length;
		packetStream.Read(&m_eRating, sizeof(m_eRating));
		packetStream.Read(&length, sizeof(length));

		if (length > packetStream.GetLength() - packetStream.GetPosition())
			length = packetStream.GetLength() - packetStream.GetPosition();
		if (length > 50)
			length = 50;

		if (length > 0)
		{
			packetStream.Read(m_strComment.GetBuffer(length + 1), length);
			m_strComment.ReleaseBuffer(length);
		//	Commentfilter
			CString strList(g_eMuleApp.m_pGlobPrefs->GetCommentFilter().MakeLower());
			if (!strList.IsEmpty())
			{
			//	Make a copy of casesensitive comment
				CString lowComment(m_strComment);
			//	Lowercase copy to search in
				lowComment.MakeLower();	
				int curPos = 0;
				CString resToken(strList.Tokenize(_T("|"), curPos));
				while (!resToken.IsEmpty())
				{
					if (lowComment.Find(resToken) > -1)
					{
						AddDebugLogLine( RGB_LOG_DIMMED + _T("Description by client '%s' for file '%s' filtered: %s"),
										 m_strUserName, m_pReqPartFile->GetFileName(), m_strComment );
						m_strComment.Empty();
						m_eRating = PF_RATING_NONE;
						break;
					}
					resToken = strList.Tokenize(_T("|"), curPos);
				}
			}
			if (!m_strComment.IsEmpty())
			{
				m_pReqPartFile->SetHasComment(true);
				AddDebugLogLine( _T("Description by client '%s' for file '%s' received: %s"),
								 m_strUserName, m_pReqPartFile->GetFileName(), m_strComment );
			}
		}
		if (m_eRating != PF_RATING_NONE)
		{
			m_pReqPartFile->SetHasRating(true);
			AddDebugLogLine( _T("Rating by client '%s' for file '%s' received: %s"),
							 m_strUserName, m_pReqPartFile->GetFileName(), ::GetRatingString(m_eRating) );
		}
		if ((!m_strComment.IsEmpty()) || (m_eRating != PF_RATING_NONE))
			m_pReqPartFile->RemovePastComment(this, false);
	}
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::Disconnected(bool bRetryConnection /*=true*/)
{
	bool	bDeleted = false;

	EMULE_TRY

	if (g_eMuleApp.m_pClientList->IsValidClient(this))
	{
	//	If the client is uploading, remove it from the upload queue.
		if (GetUploadState() == US_UPLOADING)
			g_eMuleApp.m_pUploadQueue->RemoveFromUploadQueue(this, ETS_DISCONNECT);

	//	Clear upload block lists, otherwise unrequested stuck blocks can be uploaded during next upload to the same client.
	//	That could happen when next time a remote client requests different blocks. That could be if a remote client:
	//	1) received some data from us and connection was lost.
	//	2) lost connection with us, but received these blocks from another client.
		ClearUploadBlockRequests();

	//	If the client is downloading, leave it on the queue but stop it from downloading
		if (GetDownloadState() == DS_DOWNLOADING)
			SetDownloadState(DS_ONQUEUE);
	// The remote client does not have to answer with OP_HASHSETANSWER *immediatly*
	// after we've sent OP_HASHSETREQUEST. It may occur that a (buggy) remote client
	// is sending us another OP_FILESTATUS which would let us change to DL-state DS_ONQUEUE.
		if (((GetDownloadState() == DS_REQHASHSET) || m_fRequestingHashSet) && m_pReqPartFile != NULL)
			m_pReqPartFile->m_bHashSetNeeded = true;
		ASSERT(g_eMuleApp.m_pClientList->IsValidClient(this));

	//	Check if this client is needed in any way, if not delete it
		bool bDelete = true;

		switch (m_eUploadState)
		{
			case US_ONUPLOADQUEUE:
			{
				bDelete = false;
			}
		};
		switch (m_eDownloadState)
		{
			case DS_ONQUEUE:
			case DS_TOOMANYCONNS:
			case DS_NONEEDEDPARTS:
			case DS_LOWTOLOWIP:
			{
				bDelete = false;
			}
		};

		switch (m_eUploadState)
		{
			case US_CONNECTING:
			case US_WAITCALLBACK:
			case US_ERROR:
			{
				bDelete = true;
			}
		};
		switch (m_eDownloadState)
		{
			case DS_CONNECTING:
			{
				m_byteFailedCount++;
				if (bRetryConnection && m_byteFailedCount <= 2)
				{
					TryToConnect();
					return bDeleted;
				}
			}
			case DS_WAITCALLBACK:
			case DS_ERROR:
			{
				bDelete = true;
			}
		};

		if (GetChatState() != MS_NONE)
		{
			bDelete = false;
			g_eMuleApp.m_pdlgEmule->m_wndChat.m_ctlChatSelector.ConnectingResult(this, false);
		}
#ifdef OLD_SOCKETS_ENABLED
		g_eMuleApp.m_pListenSocket->DeleteSocket(m_pRequestSocket);
#endif //OLD_SOCKETS_ENABLED

		if (m_iFileListRequested)
		{
			AddLogLine(true, IDS_SHAREDFILES_FAILED, m_strUserName);
			m_iFileListRequested = m_iFileListRequestedSave = 0;
		}
		if (m_pFriend)
		{
			g_eMuleApp.m_pFriendList->RefreshFriend(m_pFriend);
		}

		if (bDelete)
		{
			delete this;
			bDeleted = true;
		}
		else
		{
			g_eMuleApp.m_pClientList->UpdateClient(this);
			m_dwEnteredConnectedState = 0;
			m_fRequestingHashSet = 0;
		}
	}

	EMULE_CATCH

	return bDeleted;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::TryToConnect(bool bIgnoreMaxCon)
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
//	If we have too many sockets open and we're not already connected...
	if ((g_eMuleApp.m_pListenSocket->TooManySockets() && !bIgnoreMaxCon) && !(m_pRequestSocket != NULL && m_pRequestSocket->IsConnected()))
	{
		Disconnected();
		return false;
	}

//	Filter LowIDs separately from HighIDs

//	If the client has a client IP...
	if (m_dwUserIP > 0)
	{
	//	case 1: it's a Client with known IP, always test the client IP instead of the client ID.
		if (g_eMuleApp.m_pIPFilter->IsFiltered(m_dwUserIP))
		{
			if (!g_eMuleApp.m_pGlobPrefs->IsCMNotLog())
			{
				AddDebugLogLine( RGB_LOG_DIMMED + _T("Filtered client (don't connect): %s %s"),
								 GetFullIP(), g_eMuleApp.m_pIPFilter->GetLastHit() );
			}
		//	Disconnect and don't retry.
			Disconnected(false);
			InterlockedIncrement(&g_eMuleApp.m_lOutgoingFiltered);
			InterlockedIncrement(&g_eMuleApp.m_lTotalFiltered);
			return false;
		}
	}
//	If the client has no IP...
	else
	{
	//	If the client has a high ID...
		if (m_dwUserID > 0xFFFFFF)
		{
		//	case 2: it's HighID with client IP empty, test client ID instead
			if (g_eMuleApp.m_pIPFilter->IsFiltered(m_dwUserID))
			{
				if (!g_eMuleApp.m_pGlobPrefs->IsCMNotLog())
					AddDebugLogLine( RGB_LOG_DIMMED + _T("Filtered client (don't connect): %s %s"),
									 GetFullIP(), g_eMuleApp.m_pIPFilter->GetLastHit() );
				Disconnected(false);
				InterlockedIncrement(&g_eMuleApp.m_lOutgoingFiltered);
				InterlockedIncrement(&g_eMuleApp.m_lTotalFiltered);
				return false;
			}
		}
		else
		{
		//	case 3: it's a LowID without known IP, cannot test yet
		//	AddDebugLogLine( RGB_LOG_DIMMED + _T("%s: Cannot filter LowID (no IP yet): m_uUserID %u m_dwUserIP %u GetFullIP %s"),
		//					 __FUNCTION__, m_dwUserID,m_dwUserIP,GetFullIP() );
		}
	}

//	If we both have Low IDs...
	if ((g_eMuleApp.m_pServerConnect->GetClientID() < 0x1000000) && HasLowID())
	{
		if (GetDownloadState() == DS_CONNECTING)
		{
			SetDownloadState(DS_LOWTOLOWIP);
		}
		else if (GetDownloadState() == DS_REQHASHSET)
		{
			SetDownloadState(DS_ONQUEUE);
			m_pReqPartFile->m_bHashSetNeeded = true;
		}
		if (GetUploadState() == US_CONNECTING)
		{
			Disconnected(false);
		}

		return false;
	}
#endif OLD_SOCKETS_ENABLED

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL)
	{
		m_pRequestSocket = new CClientReqSocket(this);
		if (!m_pRequestSocket->Create())
		{
			m_pRequestSocket->Safe_Delete();
			return true;
		}
	}
	else if (!m_pRequestSocket->IsConnected())
	{
		m_pRequestSocket->Safe_Delete();
		m_pRequestSocket = new CClientReqSocket(this);
		if (!m_pRequestSocket->Create())
		{
			m_pRequestSocket->Safe_Delete();
			return true;
		}
	}
//	If we already have a connected request socket, we're done
	else
	{
		ConnectionEstablished();
		return true;
	}
#endif OLD_SOCKETS_ENABLED
//	MOD Note: Do not change this part - Merkur
	if (HasLowID())
	{
		if (GetDownloadState() == DS_CONNECTING)
		{
			SetDownloadState(DS_WAITCALLBACK);
		}
		if (GetUploadState() == US_CONNECTING)
		{
			Disconnected();
			return false;
		}

#ifdef OLD_SOCKETS_ENABLED
	//	If the client is on the same server that we are...
		if (g_eMuleApp.m_pServerConnect->IsLocalServer(m_dwServerIP, m_uServerPort))
		{
			Packet		*pPacket = new Packet(OP_CALLBACKREQUEST, 4);

			memcpy2(pPacket->m_pcBuffer, &m_dwUserID, 4);
			g_eMuleApp.m_pUploadQueue->AddUpDataOverheadServer(pPacket->m_dwSize);
			g_eMuleApp.m_pServerConnect->SendPacket(pPacket);
		}
	//	If the LowID client is on another server...
		else
		{
		//	If we're not uploading to him or currently downloading...
			if (GetUploadState() == US_NONE && (!GetRemoteQueueRank() || m_bReaskPending))
			{
				g_eMuleApp.m_pDownloadQueue->RemoveSource(this);
				Disconnected();
				return false;
			}
			else
			{
				if (GetDownloadState() == DS_WAITCALLBACK)
				{
					m_bReaskPending = true;
					SetDownloadState(DS_ONQUEUE);
				}
			}
		}
#endif //OLD_SOCKETS_ENABLED

	}
//	MOD Note - end
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		m_pRequestSocket->Connect(GetFullIP(), GetUserPort());
#endif //OLD_SOCKETS_ENABLED

		SendHelloPacket();
	}
	return true;

	EMULE_CATCH
	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ConnectionEstablished()
{
	EMULE_TRY

	m_byteFailedCount = 0;

//	Ok we have a connection, let's see if we want anything from this client.

//	If we're connecting for chat...
	if (GetChatState() == MS_CONNECTING)
	{
		g_eMuleApp.m_pdlgEmule->m_wndChat.m_ctlChatSelector.ConnectingResult(this, true);
	}
//	If we're connecting for download...
	switch (GetDownloadState())
	{
		case DS_CONNECTING:
		case DS_WAITCALLBACK:
			m_bReaskPending = false;
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
	}
//	If we're connecting for a "reask"...
	if (m_bReaskPending)
	{
		m_bReaskPending = false;
		if (GetDownloadState() != DS_NONE && GetDownloadState() != DS_DOWNLOADING)
		{
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
		}
	}
//	If we're connecting for upload...
	switch (GetUploadState())
	{
		case US_CONNECTING:
		case US_WAITCALLBACK:
		{
			if (g_eMuleApp.m_pUploadQueue->IsDownloading(this))
			{
				SetUploadState(US_UPLOADING);

				Packet		*pPacket = new Packet(OP_ACCEPTUPLOADREQ);

				g_eMuleApp.m_pUploadQueue->AddUpDataOverheadFileRequest(pPacket->m_dwSize);

#ifdef OLD_SOCKETS_ENABLED
				m_pRequestSocket->SendPacket(pPacket, true);
#endif OLD_SOCKETS_ENABLED

			//	Set Upload Timer
				SetLastGotULData();
			}
		}
	}
//	If we're connecting to retrieve the client's file list...
	if (m_iFileListRequested == 1)
	{
		Packet		*pPacket = new Packet((m_fSupportsAskSharedDirs != 0) ? OP_ASKSHAREDDIRS : OP_ASKSHAREDFILES);

		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);

#ifdef OLD_SOCKETS_ENABLED
		m_pRequestSocket->SendPacket(pPacket, true, true);
#endif OLD_SOCKETS_ENABLED
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CUpDownClient::GetHashType()
{
	if (m_userHash[5] == 14 && m_userHash[14] == 111)
		return SO_EMULE;
	else if (m_userHash[5] == 13 && m_userHash[14] == 110)
		return SO_OLDEMULE;
	else if (m_userHash[5] == 'M' && m_userHash[14] == 'L')
		return SO_MLDONKEY;
	else
		return SO_UNKNOWN;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ReGetClientSoft()
{
	EMULE_TRY

//	If this client hasn't been contacted, it is SO_UNKNOWN
	if (m_strUserName.IsEmpty())
	{
		m_eClientSoft = SO_UNKNOWN;
		return;
	}
//	In some cases at the time of OP_EMULEINO (which is received before OP_HELLOANSWER)
//	user hash can be zero. The processing will be done on OP_HELLOANSWER reception
	if (!HasValidHash())
		return;

	uint32	dwMajVer, dwMinVer, dwUpdVer;
	int		iHashType = GetHashType();

	switch (iHashType)
	{
	//	If a client is an old emule...
		case SO_OLDEMULE:
		{
			if ((m_byteEmuleVersion != 0x99) && (m_byteCompatibleClient == 0) && !m_bIsML)
			{
				m_eClientSoft = SO_OLDEMULE;
				m_strClientSoft.Format(_T("%s v0.%u"), GetResString(IDS_OLDEMULE), m_dwClientVersion);
				m_dwClientVersion = FORM_CLIENT_VER(0, m_dwClientVersion, 0);
				break;
			}
		}
	//	If a client is eMule compatible client...
		case SO_EMULE:
		{
			m_eClientSoft = GetClientTypeFromCompatibilityTag(m_byteCompatibleClient);
			if ((m_eClientSoft == SO_EMULE) || (m_eClientSoft == SO_UNKNOWN))
			{
				if (m_bIsML)
				{
					m_eClientSoft = SO_MLDONKEY;
					if (m_byteEmuleVersion == 0)	//neither CT_EMULE_VERSION nor OP_EMULEINFO was received
					{
						m_strClientSoft.Format(_T("MLdonkey v0.%u"), m_dwClientVersion);
						m_dwClientVersion = FORM_CLIENT_VER(0, m_dwClientVersion, 0);
						break;
					}
				}
				else if (m_bIsHybrid)
				{
					m_eClientSoft = SO_EDONKEYHYBRID;
				}
				else if (m_eClientSoft == SO_UNKNOWN)
				{
					m_eClientSoft = SO_EMULE;
					AddDebugLogLine( _T("New Compatible ClientSoft %u (%s) - listed as eMule"),
									 m_byteCompatibleClient, HashToString(m_userHash) );
				}
			}
			if ((m_dwPlusVers != 0) && (m_eClientSoft != SO_EMULE))
				m_dwPlusVers = 0;

			CString	strClientVer = _T(" ?");

			if (m_dwPlusVers != 0)
			{
			//	Adjust old client identification to the new style
				dwMajVer = m_dwPlusVers >> 8;
				dwMinVer = (m_dwPlusVers >> 4) & 0xF;
				dwUpdVer = m_dwPlusVers & 0xF;

				if ( !m_strModString.IsEmpty() &&
					(memcmp(m_strModString.GetString(), _T("Plus"), sizeof(_T("Plus")) - sizeof(TCHAR)) == 0) )
				{
					m_strModString.Empty();
				}
				m_eClientSoft = SO_PLUS;
				goto AdjustOldIdentification;
			}
			if (m_byteEmuleVersion == 0)
			{
				m_dwClientVersion = FORM_CLIENT_VER(0, 0, 0);
			}
			else if (m_byteEmuleVersion != 0x99)
			{
				dwMinVer = (m_byteEmuleVersion >> 4) * 10 + (m_byteEmuleVersion & 0xF);
				m_dwClientVersion = FORM_CLIENT_VER(0, dwMinVer, 0);
				strClientVer.Format(_T("0.%u"), dwMinVer);
			}
			else
			{
				dwMajVer = (m_dwClientVersion >> 17) & 0x7F;
				dwMinVer = (m_dwClientVersion >> 10) & 0x7F;
				dwUpdVer = (m_dwClientVersion >>  7) & 0x07;

AdjustOldIdentification:
				m_dwClientVersion = FORM_CLIENT_VER(dwMajVer, dwMinVer, dwUpdVer);

				if (m_eClientSoft == SO_PLUS)
				{
					if (m_dwPlusVers == 0)
						m_dwPlusVers = (dwMajVer << 8) | ((dwMinVer & 0xF) << 4) | dwUpdVer;
					strClientVer.Format(_T("%u"), dwMajVer);
					if (dwMinVer != 0)
						strClientVer.AppendFormat(_T(".%u"), dwMinVer);
					if (dwUpdVer != 0)
						strClientVer += static_cast<TCHAR>(_T('a') + dwUpdVer - 1);
				}
				else if ((m_eClientSoft == SO_EMULE) && (dwUpdVer < 26))
					strClientVer.Format(_T("%u.%u%c"), dwMajVer, dwMinVer, _T('a') + dwUpdVer);
				else if ((m_eClientSoft == SO_AMULE) || (dwUpdVer != 0))
					strClientVer.Format(_T("%u.%u.%u"), dwMajVer, dwMinVer, dwUpdVer);
				else
					strClientVer.Format(_T("%u.%u"), dwMajVer, dwMinVer);
			}
			if (m_strModString.IsEmpty())
				m_strClientSoft.Format(_T("%s v%s"), GetClientNameString(m_eClientSoft), strClientVer);
			else
				m_strClientSoft.Format(_T("%s v%s [%s]"), GetClientNameString(m_eClientSoft), strClientVer, m_strModString);
			break;
		}
		default:
		//	If a client is eDonkey-Hybrid...
			if (m_bIsHybrid)
			{
				m_eClientSoft = SO_EDONKEYHYBRID;

			//	I've never seen such idiotic version format in my life. Exampes:
			//	105321 - eDonkey 0.53.21
			//	1053   - eDonkey 0.53
			//	10502  - eDonkey 0.50.2
			//	1044   - eDonkey 0.44
			//	1432   - eDonkey 0.43.2 (first hybrid version)
			//	53248  - Overnet 0.53.24.8
			//	531    - Overnet 0.53.1
			//	53     - Overnet 0.53
			//	1000   - combined eDonkey-Overnet 1.0
			//	1001   - combined eDonkey-Overnet 1.0.1
			//	10200  - combined eDonkey-Overnet 1.2.0

			//	Convert eDonkey format into Overnet
				if (((m_dwClientVersion >= 1044) && (m_dwClientVersion < 1054)) || (m_dwClientVersion == 1432))
					m_dwClientVersion -= 1000;
				else if ((m_dwClientVersion > 10440) && (m_dwClientVersion < 10540))
					m_dwClientVersion -= 10000;
				else if ((m_dwClientVersion > 104400) && (m_dwClientVersion < 105400))
					m_dwClientVersion -= 100000;

				if (m_dwClientVersion < 1000)
				{
					dwMajVer = 0;
					if (m_dwClientVersion < 100)
					{
						dwMinVer = m_dwClientVersion;
						dwUpdVer = 0;
					}
					else
					{
						dwMinVer = m_dwClientVersion / 10;
						dwUpdVer = m_dwClientVersion - dwMinVer * 10;
					}
				}
				else if ((m_dwClientVersion > 4400) && (m_dwClientVersion < 5400))
				{
					dwMajVer = 0;
					dwMinVer = m_dwClientVersion / 100;
					dwUpdVer = m_dwClientVersion - dwMinVer * 100;
				}
				else if ((m_dwClientVersion > 44000) && (m_dwClientVersion < 54000))
				{
					dwMajVer = 0;
					dwMinVer = m_dwClientVersion / 1000;
					dwUpdVer = m_dwClientVersion / 10 - dwMinVer * 100;	//skip minor build number
				}
				else
				{
					if (m_dwClientVersion >= 10000)	// that's just an assumption
					{
						dwMajVer = m_dwClientVersion / 10000;
						m_dwClientVersion -= dwMajVer * 10000;
					}
					else
					{
						dwMajVer = m_dwClientVersion / 1000;
						m_dwClientVersion -= dwMajVer * 1000;
					}
					dwMinVer = m_dwClientVersion / 100;
					dwUpdVer = m_dwClientVersion - dwMinVer * 100;
				}
				m_dwClientVersion = FORM_CLIENT_VER(dwMajVer, dwMinVer, dwUpdVer);

				if (dwUpdVer)
					m_strClientSoft.Format(_T("Hybrid v%u.%u.%u"), dwMajVer, dwMinVer, dwUpdVer);
				else
					m_strClientSoft.Format(_T("Hybrid v%u.%u"), dwMajVer, dwMinVer);
			}
		//	If a client is MLdonkey...
			else if (m_bIsML || (iHashType == SO_MLDONKEY))
			{
				m_eClientSoft = SO_MLDONKEY;
				m_strClientSoft.Format(_T("MLdonkey v0.%u"), m_dwClientVersion);
				m_dwClientVersion = FORM_CLIENT_VER(0, m_dwClientVersion, 0);
			}
			else
			{
				m_eClientSoft = SO_EDONKEY;
				m_strClientSoft.Format(_T("eDonkey v0.%u"), m_dwClientVersion);
				m_dwClientVersion = FORM_CLIENT_VER(0, m_dwClientVersion, 0);
			}
			break;
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::RequestSharedFileList()
{
	EMULE_TRY

	if (m_iFileListRequested == 0)
	{
		AddLogLine(true, IDS_SHAREDFILES_REQUEST, m_strUserName);
		m_iFileListRequested = m_iFileListRequestedSave = 1;
		TryToConnect(true);
	}
	else
	{
		AddLogLine(true, IDS_SHAREDFILES_INPROGRESS, m_strUserName, GetUserID());
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessSharedFileList(char *pachPacket, uint32 dwSize, LPCTSTR strDirectory)
{
	EMULE_TRY

	if (m_iFileListRequested > 0)
	{
		bool		bFirstDir = (m_iFileListRequested == m_iFileListRequestedSave);

		m_iFileListRequested--;
		g_eMuleApp.m_pSearchList->ProcessSharedFileListAnswer(pachPacket, dwSize, this, strDirectory, bFirstDir);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString CUpDownClient::GetUploadFileInfo()
{
	if (this == NULL)
		return _T("");

	CString strInfo;
	CKnownFile *pReqFile = g_eMuleApp.m_pSharedFilesList->GetFileByID(this->m_reqFileHash);

//	Build info text and display it
	strInfo.Format(GetResString(IDS_USERINFO), m_strUserName, GetUserID());
	if (pReqFile)
	{
		strInfo.AppendFormat( GetResString(IDS_SF_REQUESTED) + _T(' ') + pReqFile->GetFileName() + _T('\n') + GetResString(IDS_FILESTATS_SESSION) + 
							  GetResString(IDS_FILESTATS_TOTAL), pReqFile->statistic.GetAccepts(), pReqFile->statistic.GetRequests(),
							  CastItoXBytes(pReqFile->statistic.GetTransferred()), pReqFile->statistic.GetAllTimeAccepts(),
							  pReqFile->statistic.GetAllTimeRequests(), CastItoXBytes(pReqFile->statistic.GetAllTimeTransferred()) );
	}
	else
		strInfo += GetResString(IDS_REQ_UNKNOWNFILE);

	return strInfo;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SetUserHash(uchar* m_achstrTempUserHash)
{
	if (m_achstrTempUserHash == NULL)
	{
		md4clr(m_userHash);
	}
	else
	{
		md4cpy(m_userHash, m_achstrTempUserHash);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
HICON CUpDownClient::GetClientInfo4Tooltips(CString &strInfo, bool bForUpload /*false*/)
{
	EMULE_TRY

	if (this == NULL)
		return (HICON)NULL;

	CString		strCountry, strUserName(m_strUserName);

	strUserName.Trim();
	strUserName.Replace(_T("\n"), _T("<br>"));
	strUserName.Replace(_T("<"), _T("<<"));
	if (g_eMuleApp.m_pIP2Country->IsIP2Country())
		 strCountry.Format(_T(" (<b>%s</b>)"), GetCountryName());

	strInfo.Format(_T("<t=1><b>%s</b><br><t=1>%s: %u%s<br><hr=100%%><br><b>%s:<t></b>%s:%u (<b>%s</b>)"),
		strUserName, GetResString(IDS_USERID), GetUserID(), strCountry,
		GetResString(IDS_CLIENT), GetFullIP(), GetUserPort(), m_strClientSoft);

	CServer *pServer = g_eMuleApp.m_pServerList->GetServerByIP(GetServerIP(), GetServerPort());

	if (pServer != NULL)
	{
		CString			strServerName = pServer->GetListName();
		in_addr			serverAddr;

		serverAddr.S_un.S_addr = GetServerIP();
		strInfo.AppendFormat(_T("<br><b>%s:<t></b>%s:%d"), GetResString(IDS_SERVER), inet_ntoa(serverAddr), GetServerPort());

		strServerName.Replace(_T("<"), _T("<<"));
		strServerName.Replace(_T("\n"), _T("<br>"));
		if (!strServerName.IsEmpty())
		{
			strInfo += _T(" (<b>");
			strInfo += strServerName;
			strInfo += _T("</b>)");
		}
	}

	if (Credits() != NULL && Credits()->GetUploadedTotal() != GetTransferredUp())
		strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s (%s)"), GetResString(IDS_STATS_DDATA), CastItoXBytes(GetTransferredUp()), CastItoXBytes(Credits()->GetUploadedTotal()));
	else if (GetTransferredUp() > 0)
		strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s"), GetResString(IDS_STATS_DDATA), CastItoXBytes(GetTransferredUp()));

	if (Credits() != NULL && Credits()->GetDownloadedTotal() != GetTransferredDown())
		strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s (%s)"), GetResString(IDS_STATS_UDATA), CastItoXBytes(GetTransferredDown()), CastItoXBytes(Credits()->GetDownloadedTotal()));
	else if (GetTransferredDown() > 0)
		strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s"), GetResString(IDS_STATS_UDATA), CastItoXBytes(GetTransferredDown()));

	if (bForUpload)
	{
		CKnownFile *m_pReqSharedFile = g_eMuleApp.m_pSharedFilesList->GetFileByID(this->m_reqFileHash);

		if (m_pReqSharedFile)
		{
			strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s<br><b>%s:</b><t>"), GetResString(IDS_TT_REQUESTED), m_pReqSharedFile->GetFileName(), GetResString(IDS_TT_FILESTATS_SESSION));
			strInfo.AppendFormat(GetResString(IDS_TT_FILESTATS), m_pReqSharedFile->statistic.GetAccepts(), m_pReqSharedFile->statistic.GetRequests(), CastItoXBytes(m_pReqSharedFile->statistic.GetTransferred()));
			strInfo.AppendFormat(_T("<br><b>%s:</b><t>"), GetResString(IDS_TT_FILESTATS_TOTAL));
			strInfo.AppendFormat(GetResString(IDS_TT_FILESTATS), m_pReqSharedFile->statistic.GetAllTimeAccepts(), m_pReqSharedFile->statistic.GetAllTimeRequests(), CastItoXBytes(m_pReqSharedFile->statistic.GetAllTimeTransferred()));
		}
		else
			strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s"), GetResString(IDS_TT_REQUESTED), GetResString(IDS_REQ_UNKNOWNFILE));
	}

	return g_eMuleApp.m_pdlgEmule->m_clientImgLists[CLIENT_IMGLST_PLAIN].ExtractIcon(GetClientIconIndex());

	EMULE_CATCH

	return (HICON)NULL;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	SendPublicKeyPacket() sends our public key to the client that requested it.
void CUpDownClient::SendPublicKeyPacket()
{
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(AddDebugLogLine(_T("%s: Sending public key to '%s'"), __FUNCTION__, m_strUserName));
#endif

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || m_eSecureIdentState != IS_KEYANDSIGNEEDED)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;

	Packet		*pPacket = new Packet(OP_PUBLICKEY, g_eMuleApp.m_pClientCreditList->GetPubKeyLen() + 1, OP_EMULEPROT);

	g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
	memcpy2(pPacket->m_pcBuffer + 1, g_eMuleApp.m_pClientCreditList->GetPublicKey(), g_eMuleApp.m_pClientCreditList->GetPubKeyLen());
	pPacket->m_pcBuffer[0] = g_eMuleApp.m_pClientCreditList->GetPubKeyLen();
#ifdef OLD_SOCKETS_ENABLED

	m_pRequestSocket->SendPacket(pPacket, true, true);
#endif //OLD_SOCKETS_ENABLED

	m_eSecureIdentState = IS_SIGNATURENEEDED;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendSignaturePacket()
{
//	Sign the public key of this client and send it
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || m_eSecureIdentState == 0)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED

	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;

//	We don't have his public key yet, will be back here later
	if (m_pCredits->GetSecIDKeyLen() == 0)
		return;
#ifdef DEBUG_SHOW_SECUREID

	DEBUG_ONLY(AddDebugLogLine(_T("%s: Sending signature key to '%s'"), __FUNCTION__, m_strUserName));
#endif
//	Do we have a challenge value received (actually we should if we are in this function)
	if (m_pCredits->m_dwCryptRndChallengeFrom == 0)
	{
		AddDebugLogLine(_T("Client '%s' want to send signature but challenge value is invalid"), m_strUserName);
		return;
	}
//	v2, we will use v1 as default, except if only v2 is supported
	bool		bUseV2;

	if ((m_byteSupportSecIdent & 1) == 1)
		bUseV2 = false;
	else
		bUseV2 = true;

	byte		byteChallengeIPKind = 0;
	uint32		ChallengeIP = 0;
#ifdef OLD_SOCKETS_ENABLED

	if (bUseV2)
	{
		if (g_eMuleApp.m_pServerConnect->GetClientID() == 0 || g_eMuleApp.m_pServerConnect->IsLowID())
		{
		//	We cannot know for sure our public ip, so use the remote clients one
			ChallengeIP = GetIP();
			byteChallengeIPKind = CRYPT_CIP_REMOTECLIENT;
		}
		else
		{
			ChallengeIP = g_eMuleApp.m_pServerConnect->GetClientID();
			byteChallengeIPKind = CRYPT_CIP_LOCALCLIENT;
		}
	}
#endif //OLD_SOCKETS_ENABLED
	uchar		achBuffer[250];
	byte		siglen = g_eMuleApp.m_pClientCreditList->CreateSignature(m_pCredits, achBuffer, 250, ChallengeIP, byteChallengeIPKind);

	if (siglen == 0)
	{
		ASSERT (false);
		return;
	}
	Packet		*pPacket = new Packet(OP_SIGNATURE, siglen + 1 + ((bUseV2) ? 1 : 0), OP_EMULEPROT);

	g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
	memcpy2(pPacket->m_pcBuffer + 1, achBuffer, siglen);
	pPacket->m_pcBuffer[0] = siglen;
	if (bUseV2)
		pPacket->m_pcBuffer[1 + siglen] = byteChallengeIPKind;
#ifdef OLD_SOCKETS_ENABLED

	m_pRequestSocket->SendPacket(pPacket, true, true);
#endif //OLD_SOCKETS_ENABLED

	m_eSecureIdentState = IS_ALLREQUESTSSEND;
}

void CUpDownClient::ProcessPublicKeyPacket(uchar* pbytePacket, uint32 dwSize)
{
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(_T("%s: Receiving public key from '%s'"), __FUNCTION__, m_strUserName));
#endif

#ifdef OLD_SOCKETS_ENABLED
	if ( m_pRequestSocket == NULL || m_pCredits == NULL || pbytePacket[0] != dwSize - 1
	     || dwSize == 0 || dwSize > 250 )
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;
//	the function will handle everything (mulitple key etc)
	if (m_pCredits->SetSecureIdent(pbytePacket + 1, pbytePacket[0]))
	{
	//	if this client wants a signature, now we can send him one
		if (m_eSecureIdentState == IS_SIGNATURENEEDED)
		{
			SendSignaturePacket();
		}
		else if (m_eSecureIdentState == IS_KEYANDSIGNEEDED)
		{
		//	Something is wrong
			AddDebugLogLine( _T("Client '%s': Invalid State error, IS_KEYANDSIGNEEDED in ProcessPublicKeyPacket"),
							 m_strUserName );
		}
	}
	else
	{
		AddDebugLogLine(_T("Client '%s' failed to use new received public key"), m_strUserName);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessSignaturePacket(uchar *pbytePacket, uint32 dwSize)
{
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(AddDebugLogLine(_T("%s: Receiving signature from '%s'"), __FUNCTION__, m_strUserName));
#endif

//	Here we separate the good guys from the bad ones ;)

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || dwSize == 0 || dwSize > 250)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED

	byte	byteChallengeIPKind, byteSigLen = pbytePacket[0];

//	If the packet consists only of the signature length and signature (SecureIdent V1)...
	if (dwSize == sizeof(byteSigLen) + byteSigLen)
	{
		byteChallengeIPKind = 0;
	}
//	If the packet is long enough to contain the challenge IP kind (SecureIdent V2) and the client supports V2...
	else if ( (dwSize == byteSigLen + sizeof(byteSigLen) + sizeof(byteChallengeIPKind)) &&
		((m_byteSupportSecIdent & 2) > 0))
	{
		byteChallengeIPKind = pbytePacket[dwSize - 1];
	}
	else
	{
		ASSERT (false);
		return;
	}

	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;

//	If we already have a signature from this client IP...
	if (m_dwLastSignatureIP == GetIP())
	{
	//	We accept only one signature per IP, to avoid floods which need a lot cpu time for crypt functions
		AddDebugLogLine(_T("Received multiple signatures from client %s"), GetClientNameWithSoftware());
		return;
	}
//	If we don't have a public key for this client...
	if (m_pCredits->GetSecIDKeyLen() == 0)
	{
		AddDebugLogLine(_T("Received signature for client %s without public key"), GetClientNameWithSoftware());
		return;
	}
//	If we haven't generated a challenge value for this client yet...
	if (m_pCredits->m_dwCryptRndChallengeFor == 0)
	{
		AddDebugLogLine(_T("Received signature for client %s with invalid challenge value"), GetClientNameWithSoftware());
		return;
	}

	if (g_eMuleApp.m_pClientCreditList->VerifyIdent(m_pCredits, pbytePacket + 1, byteSigLen, GetIP(), byteChallengeIPKind))
	{
	//	result is saved in function above
	}
#ifdef DEBUG_SHOW_SECUREID
	else
	{
		AddDebugLogLine(_T("Client %s has failed the secure identification, V2 State: %i"), GetClientNameWithSoftware(), byteChallengeIPKind);
	}
#endif

	m_dwLastSignatureIP = GetIP();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendSecIdentStatePacket()
{
//	Check if we need public key and signature
	BYTE		byteValue = 0;

	if (m_pCredits != NULL)
	{
		if (g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		{
			if (m_pCredits->GetSecIDKeyLen() == 0)
			{
				byteValue = IS_KEYANDSIGNEEDED;
			}
			else if (m_dwLastSignatureIP != GetIP())
			{
				byteValue = IS_SIGNATURENEEDED;
			}
		}
	//	If we already have the key and signature, we're done.
		if (byteValue == 0)
		{
#ifdef DEBUG_SHOW_SECUREID
			DEBUG_ONLY(AddDebugLogLine(_T("%s: Not sending SecIdentState Packet, because State is Zero"), __FUNCTION__));
#endif
			return;
		}
	//	Crypt: send random data to sign
		uint32		dwRandom = rand() + 1;

		m_pCredits->m_dwCryptRndChallengeFor = dwRandom;

#ifdef DEBUG_SHOW_SECUREID
		DEBUG_ONLY(AddDebugLogLine(_T("%s: Sending SecIdentState packet, state: %i (to '%s')"), __FUNCTION__, byteValue, m_strUserName));
#endif

		Packet		*pPacket = new Packet(OP_SECIDENTSTATE, 5, OP_EMULEPROT);

		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(pPacket->m_dwSize);
		pPacket->m_pcBuffer[0] = byteValue;
		memcpy2(pPacket->m_pcBuffer + 1, &dwRandom, sizeof(dwRandom));

#ifdef OLD_SOCKETS_ENABLED
		m_pRequestSocket->SendPacket(pPacket, true, true);
#endif //OLD_SOCKETS_ENABLED

	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ProcessSecIdentStatePacket(uchar *pbytePacket, uint32 dwSize)
{
	if (dwSize != 5)
		return;
	if (m_pCredits == NULL)
		return;

	switch (pbytePacket[0])
	{
		case 0:
			m_eSecureIdentState = IS_UNAVAILABLE;
			break;
		case 1:
			m_eSecureIdentState = IS_SIGNATURENEEDED;
			break;
		case 2:
			m_eSecureIdentState = IS_KEYANDSIGNEEDED;
			break;
	}
	uint32		dwRandom;

	memcpy2(&dwRandom, pbytePacket + 1, 4);
	m_pCredits->m_dwCryptRndChallengeFrom = dwRandom;

#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(AddDebugLogLine(_T("%s: Received SecIdentState Packet, state: %i"), __FUNCTION__, pbytePacket[0]));
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	InfoPacketsReceived() is called once the HELLO/HELLOANSWER and EMULEINFO/EMULEINFOANSWER information has
//	been received.
void CUpDownClient::InfoPacketsReceived()
{
	ASSERT (m_eInfoPacketsReceived == IP_BOTH);

	m_eInfoPacketsReceived = IP_NONE;

//	If this client supports secure credits...
	if (m_byteSupportSecIdent)
	{
		SendSecIdentStatePacket();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString CUpDownClient::GetCountryName() const
{
	return g_eMuleApp.m_pIP2Country->GetCountryNameByIndex(m_uUserCountryIdx);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ResetIP2Country()
{
	m_uUserCountryIdx = g_eMuleApp.m_pIP2Country->GetCountryFromIP(m_dwUserIP);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::HasUserNameForbiddenStrings()
{
	if (m_byteActionsOnNameChange & AONC_FORBIDDEN_NAME_CHECK)
	{
		m_bHasUserNameForbiddenStrings = IsStolenName(m_strUserName);

		m_byteActionsOnNameChange &= ~AONC_FORBIDDEN_NAME_CHECK;
	}

	return m_bHasUserNameForbiddenStrings;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::HasMODNameForbiddenStrings()
{
	if (m_bIsMODNameChanged)
	{
		m_bHasMODNameForbiddenStrings = IsLeecherType(m_strModString);

		m_bIsMODNameChanged = false;
	}

	return m_bHasMODNameForbiddenStrings;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CUpDownClient::GetClientIconIndex() const
{
	uint32	dwImgIdx = GetClientSoft();

	if ((dwImgIdx == SO_EMULE) || (dwImgIdx == SO_PLUS))
	{
		if (m_pCredits->GetCurrentIdentState(GetIP()) != IS_IDENTIFIED)
			dwImgIdx = SO_OLDEMULE;
	}
	else if (dwImgIdx > SO_UNKNOWN)
		dwImgIdx = SO_UNKNOWN;

	return static_cast<int>(dwImgIdx);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString CUpDownClient::GetFullSoftVersionString() const
{
	return m_strClientSoft;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString CUpDownClient::GetClientNameWithSoftware() const
{
	CString strBuf;

	strBuf.Format(_T("'%s' (%s)"), m_strUserName, m_strClientSoft);
	return strBuf;
}
