//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// ChatWnd.cpp : implementation file
//
#include "stdafx.h"
#include "emule.h"
#include "ChatWnd.h"
#include "IP2Country.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CChatWnd dialog

IMPLEMENT_DYNAMIC(CChatWnd, CDialog)
CChatWnd::CChatWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CChatWnd::IDD, pParent)
{
}

CChatWnd::~CChatWnd()
{
}

void CChatWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHATSEL, m_ctlChatSelector);
	DDX_Control(pDX, IDC_LIST2, m_FriendListCtrl);
	DDX_Control(pDX, IDC_CMESSAGE, m_ctlInputText);
	DDX_Control(pDX, IDC_CSEND, m_ctlSendButton);
	DDX_Control(pDX, IDC_CCLOSE, m_ctlCloseButton);
}

BEGIN_MESSAGE_MAP(CChatWnd, CResizableDialog)
	ON_WM_KEYDOWN()
	ON_WM_SHOWWINDOW()
	ON_MESSAGE(WM_CLOSETAB, OnCloseTab)
	ON_NOTIFY_EX_RANGE(UDM_TOOLTIP_DISPLAY,0,0xFFFF,OnToolTipNotify)
	ON_BN_CLICKED(IDC_CCLOSE, OnBnClickedCclose)
	ON_BN_CLICKED(IDC_CSEND, OnBnClickedCsend)
	ON_WM_DESTROY()
END_MESSAGE_MAP()
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CChatWnd message handlers
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CChatWnd::OnInitDialog()
{
	CResizableDialog::OnInitDialog();

	oldMessageIcon = GetMessageStatic()->SetIcon(GetMessageIcon());
	oldFriendsIcon = GetFriendsStatic()->SetIcon(GetFriendsIcon());

	AddAnchor(IDC_CHATSEL,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(IDC_LIST2,TOP_LEFT,BOTTOM_LEFT);
	AddAnchor(IDC_CSEND, BOTTOM_RIGHT);
	AddAnchor(IDC_CCLOSE, BOTTOM_RIGHT);
	AddAnchor(IDC_CMESSAGE, BOTTOM_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_FRIENDS_LBL,TOP_LEFT);
	AddAnchor(IDC_FRIENDSICON,TOP_LEFT);

	m_ctlChatSelector.Init();
	m_FriendListCtrl.Init();

	m_ttip.Create(this);
	m_ttip.SetDelayTime(TTDT_AUTOPOP, 15000);
	m_ttip.SetDelayTime(TTDT_INITIAL, g_eMuleApp.m_pGlobPrefs->GetToolTipDelay()*1000);
	m_ttip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX);
	m_ttip.SetBehaviour(PPTOOLTIP_MULTIPLE_SHOW);
	m_ttip.SetNotify(m_hWnd);
	m_ttip.AddTool(&m_FriendListCtrl, _T(""));

	Localize();

	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::StartSession(CUpDownClient* client)
{
	g_eMuleApp.m_pdlgEmule->SetActiveDialog(this);
	m_ctlChatSelector.StartSession(client);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::OnShowWindow(BOOL bShow,UINT nStatus)
{
	if (bShow)
		m_ctlChatSelector.ShowChat();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::OnBnClickedCclose()
{
	m_ctlChatSelector.EndSession();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::OnBnClickedCsend()
{
	CString			strNewMessage;

	m_ctlInputText.GetWindowText(strNewMessage);

	strNewMessage.Trim();
	if (!strNewMessage.IsEmpty() && m_ctlChatSelector.SendMessage(strNewMessage))
		m_ctlInputText.SetWindowText(_T(""));
	m_ctlInputText.SetFocus();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CChatWnd::PreTranslateMessage(MSG* pMsg)
{
	EMULE_TRY

	if (pMsg->message == WM_KEYDOWN && (pMsg->hwnd == m_ctlInputText.m_hWnd))
	{
		if (pMsg->wParam == VK_RETURN)
		{
			OnBnClickedCsend();
			return TRUE;
		}

		if (pMsg->wParam == VK_UP || pMsg->wParam == VK_DOWN)
		{
			ScrollHistory(pMsg->wParam == VK_DOWN);
			return TRUE;
		}
	}

	if (g_eMuleApp.m_pGlobPrefs->GetToolTipDelay() != 0)
		m_ttip.RelayEvent(pMsg);

	return CResizableDialog::PreTranslateMessage(pMsg);

	EMULE_CATCH

	return false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CChatWnd::OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult) 
{ 
	NM_PPTOOLTIP_DISPLAY	*pNotify = (NM_PPTOOLTIP_DISPLAY*)pNMH;
	int						iControlId = CWnd::FromHandle(pNotify->ti->hWnd)->GetDlgCtrlID();
	CString					strInfo;

	if (iControlId == IDC_LIST2)
	{
		int					iSel = GetItemUnderMouse(&m_FriendListCtrl);

		if (iSel < 0 || iSel == 65535)
			return FALSE;

		CFriend             *pFriend = reinterpret_cast<CFriend*>(m_FriendListCtrl.GetItemData(iSel));

		if (pFriend == NULL)
			return FALSE;

		CString				strUserName = pFriend->m_strName, strUserIP, strLaseSeen, strLastChat, strCountry;
		in_addr				host;

		strUserName.Replace(_T("<"), _T("<<"));
		host.S_un.S_addr = pFriend->m_dwLastUsedIP;
		strUserIP = inet_ntoa(host);

		if (g_eMuleApp.m_pIP2Country->IsIP2Country())
				strCountry.Format(_T(" (<b>%s</b>)"), g_eMuleApp.m_pIP2Country->GetCountryNameByIndex(g_eMuleApp.m_pIP2Country->GetCountryFromIP(pFriend->m_dwLastUsedIP)));

		if (pFriend->GetLastSeen() == 0)
			GetResString(&strLaseSeen, IDS_NEVER);
		else
		{
			CTime			ctTime(pFriend->GetLastSeen());
			SYSTEMTIME		st;

			ctTime.GetAsSystemTime(st);

			COleDateTime    odtTime(st);

			strLaseSeen = odtTime.Format();
		}

		if (pFriend->m_dwLastChatted == NULL)
			GetResString(&strLastChat, IDS_NEVER);
		else
		{
			CTime			ctTime(pFriend->m_dwLastChatted);
			SYSTEMTIME		st;

			ctTime.GetAsSystemTime(st);

			COleDateTime    odtTime(st);

			strLastChat = odtTime.Format();
		}

		strInfo.Format(_T("<t=1><b>%s</b><br><hr=100%%><br><b>%s<t></b>%s<br><b>%s<t></b>%s:%u%s<br><b>%s:<t></b>%s<br><b>%s:<t></b>%s"),
			strUserName,
			GetResString(IDS_CD_UHASH), HashToString(pFriend->GetUserHash()),
			GetResString(IDS_CD_UIP), strUserIP, pFriend->m_nLastUsedPort, strCountry,
			GetResString(IDS_LASTSEEN), strLaseSeen,
			GetResString(IDS_TT_LAST_CHAT), strLastChat);

		int			iImageIndex;

		if (pFriend->GetLinkedClient() == NULL)
			iImageIndex = 0;
		#ifdef OLD_SOCKETS_ENABLED
		else if (pFriend->GetLinkedClient()->m_pRequestSocket && pFriend->GetLinkedClient()->m_pRequestSocket->IsConnected())
			iImageIndex = 2;
		#endif //OLD_SOCKETS_ENABLED
		else
			iImageIndex = 1;

		pNotify->ti->hIcon = m_FriendListCtrl.m_imageList.ExtractIcon(iImageIndex);
	}
	pNotify->ti->sTooltip = strInfo;

	return TRUE;
} 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
void CChatWnd::Localize()
{
	static const uint16 s_auResTbl[][2] =
	{
		{ IDC_MESSAGES_LBL, IDS_CW_MESSAGES },
		{ IDC_CSEND, IDS_CW_SEND },
		{ IDC_CCLOSE, IDS_CW_CLOSE }
	};

	if (m_hWnd)
	{
		for (unsigned ui = 0; ui < ELEMENT_COUNT(s_auResTbl); ui++)
			SetDlgItemText(s_auResTbl[ui][0], GetResString(s_auResTbl[ui][1]));
		m_FriendListCtrl.Localize();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CChatWnd::OnCloseTab(WPARAM wparam, LPARAM lparam)
{
	TCITEM		tcItem;
	int			iItem = (int)wparam;

	tcItem.mask = TCIF_PARAM;
	m_ctlChatSelector.GetItem(iItem, &tcItem);
	
	m_ctlChatSelector.EndSession(((CChatItem*)tcItem.lParam)->m_pClient);

	if (iItem > 0)
		iItem--;

	if (iItem >= 0)
	{
		m_ctlChatSelector.SetCurSel(iItem);
		m_ctlChatSelector.ShowChat();
	}

	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::ScrollHistory(bool down)
{
	CChatItem		*pChatItem = m_ctlChatSelector.GetCurrentChatItem();

	if ((pChatItem == NULL) || ((pChatItem->m_iHistoryIndex == 0 && !down)
		|| (pChatItem->m_iHistoryIndex == pChatItem->m_strHistoryArray.GetCount() && down)))
		return;

	if (down)
		++pChatItem->m_iHistoryIndex;
	else
		--pChatItem->m_iHistoryIndex;

	CString			strBuffer;

	if (pChatItem->m_iHistoryIndex != pChatItem->m_strHistoryArray.GetCount())
		strBuffer = pChatItem->m_strHistoryArray.GetAt(pChatItem->m_iHistoryIndex);

	m_ctlInputText.SetWindowText(strBuffer);
	m_ctlInputText.SetSel(strBuffer.GetLength(), strBuffer.GetLength());
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CChatWnd::OnDestroy()
{
	CResizableDialog::OnDestroy();
	DestroyIcon(GetMessageStatic()->SetIcon(oldMessageIcon));
	DestroyIcon(GetFriendsStatic()->SetIcon(oldFriendsIcon));
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
