// CommentDialog.cpp : implementation file 
// 

#include "stdafx.h" 
#include "emule.h" 
#include "CommentDialog.h" 

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CommentDialog dialog 

IMPLEMENT_DYNAMIC(CCommentDialog, CDialog) 
CCommentDialog::CCommentDialog(CKnownFile* file) 
   : CDialog(CCommentDialog::IDD, 0) 
{ 
   m_file = file; 
} 

CCommentDialog::~CCommentDialog() 
{ 
} 

void CCommentDialog::DoDataExchange(CDataExchange* pDX) 
{ 
   CDialog::DoDataExchange(pDX); 
   DDX_Control(pDX, IDC_RATELIST, ratebox);//for rate 
} 

BEGIN_MESSAGE_MAP(CCommentDialog, CDialog) 
   ON_BN_CLICKED(IDC_CMT_OK, OnBnClickedApply) 
   ON_BN_CLICKED(IDC_CMT_ERASE, OnBnClickedErase)
   ON_BN_CLICKED(IDC_CMT_CANCEL, OnBnClickedCancel) 
END_MESSAGE_MAP() 

void CCommentDialog::OnBnClickedApply() 
{ 
	EMULE_TRY

	CString strValue;

	GetDlgItemText(IDC_CMT_TEXT, strValue);
// No empty comments
	if(!strValue.IsEmpty() || ((byte)ratebox.GetCurSel() != 0))
	{ 
		int ratio;
		if((byte)ratebox.GetCurSel() == 4)
			ratio = 3;
		else if ((byte)ratebox.GetCurSel() == 3)
			ratio = 4;
		else
			ratio = (byte)ratebox.GetCurSel();

		m_file->SetFileComment(strValue);
		m_file->SetFileRating(static_cast<_EnumPartFileRating>(ratio));//for Rate//
		CDialog::OnOK();
	}
	else
	{
		AfxMessageBox(GetResString(IDS_CMT_NOCOMMENT));
	}

	EMULE_CATCH
} 

void CCommentDialog::OnBnClickedErase() 
{
	EMULE_TRY

	if(AfxMessageBox(GetResString(IDS_ERASE_SURE), MB_YESNO) == IDYES)
	{
		m_file->RemoveFileCommentAndRating();
		CDialog::OnOK();
	}

	EMULE_CATCH
}

void CCommentDialog::OnBnClickedCancel() 
{ 
   CDialog::OnCancel(); 
} 

BOOL CCommentDialog::OnInitDialog(){ 
   CDialog::OnInitDialog(); 
   Localize(); 

   SetDlgItemText(IDC_CMT_TEXT, m_file->GetFileComment()); 
   ((CEdit*)GetDlgItem(IDC_CMT_TEXT))->SetLimitText(50);

   return TRUE; 
} 

void CCommentDialog::Localize(void)
{ 
	static const int s_aiResTbl[][2] =
	{
		{ IDC_CMT_OK, IDS_PW_APPLY },
		{ IDC_CMT_CANCEL, IDS_CANCEL },
		{ IDC_CMT_ERASE, IDS_ERASE },
		{ IDC_CMT_LQUEST, IDS_CMT_QUEST },
		{ IDC_CMT_LAIDE, IDS_CMT_AIDE },
		{ IDC_RATEQUEST, IDS_CMT_RATEQUEST },
		{ IDC_RATEHELP, IDS_CMT_RATEHELP }
	};
	static const UINT s_dwResCombo[] = {
		IDS_CMT_NOTRATED, IDS_CMT_FAKE, IDS_CMT_POOR,
		IDS_CMT_FAIR, IDS_CMT_GOOD, IDS_CMT_EXCELLENT
	};

	EMULE_TRY

	for (uint32 i = 0; i < ELEMENT_COUNT(s_aiResTbl); i++)
		SetDlgItemText(s_aiResTbl[i][0], GetResString(static_cast<UINT>(s_aiResTbl[i][1])));

	while (ratebox.GetCount()>0)
		ratebox.DeleteString(0); 
	
	for (uint32 i = 0; i < ELEMENT_COUNT(s_dwResCombo); i++)
		ratebox.AddString(GetResString(s_dwResCombo[i]));

	int ratio;
	if(m_file->GetFileRating() == PF_RATING_FAIR)
		ratio = 3;
	else if (m_file->GetFileRating() == PF_RATING_GOOD)
		ratio = 4;
	else
		ratio = static_cast<int>(m_file->GetFileRating());

	if(ratebox.SetCurSel(ratio)==CB_ERR)
		ratebox.SetCurSel(0); 
	 
	CString strTitle; 
	
	strTitle.Format(GetResString(IDS_CMT_TITLE), m_file->GetFileName());
	SetWindowText(strTitle); 

	EMULE_CATCH
} 
