// PPgDirectories.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgDirectories.h"
#include "AddBuddy.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgDirectories dialog

IMPLEMENT_DYNAMIC(CPPgDirectories, CPropertyPage)
CPPgDirectories::CPPgDirectories()
	: CPropertyPage(CPPgDirectories::IDD)
	, incFiles(_T(""))
	, tempFiles(_T(""))
	, vlc(_T(""))
	, videoBackup(FALSE)
	, smallBlocks(FALSE)
	, incomingDesc(_T(""))
	, tempDesc(_T(""))
	, vlcDesc(_T(""))
	, sharedDesc(_T(""))
	, tempDirDesc(_T(""))
{
	m_bSharedDirsModified = false;
}

CPPgDirectories::~CPPgDirectories()
{
}

void CPPgDirectories::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SHARESELECTOR, m_ShareSelector);
	DDX_Control(pDX, IDC_TEMPSELECTOR, m_TempSelector);
	DDX_Text(pDX, IDC_INCFILES, incFiles);
	DDX_Text(pDX, IDC_TEMPFILES, tempFiles);
	DDX_Text(pDX, IDC_VLC, vlc);
	DDX_Check(pDX, IDC_VIDEOBACKUP, videoBackup);
	DDX_Check(pDX, IDC_PREVIEW_SMALL, smallBlocks);
	DDX_Control(pDX, IDC_INCFILES, incFilesEdit);
	DDX_Control(pDX, IDC_TEMPFILES, tempFilesEdit);
	DDX_Control(pDX, IDC_VLC, vlcEdit);
	DDX_Text(pDX, IDC_INCOMING_LBL, incomingDesc);
	DDX_Text(pDX, IDC_TEMP_LBL, tempDesc);
	DDX_Text(pDX, IDC_VLC_LBL, vlcDesc);
	DDX_Text(pDX, IDC_SHARED_LBL, sharedDesc);
	DDX_Text(pDX, IDC_TEMPDIR_LBL, tempDirDesc);
	DDX_Control(pDX, IDC_VIDEOBACKUP, videoBackupCheck);
	DDX_Control(pDX, IDC_PREVIEW_SMALL, smallBlocksCheck);
	DDX_Control(pDX, IDC_SELINCDIR, selIncDirButton);
	DDX_Control(pDX, IDC_SELTEMPDIR, selTempDirButton);
	DDX_Control(pDX, IDC_SELVLC, selVlcButton);
}

BEGIN_MESSAGE_MAP(CPPgDirectories, CPropertyPage)
	ON_EN_CHANGE(IDC_INCFILES, OnEnChange)
	ON_EN_CHANGE(IDC_TEMPFILES, OnEnChange)
	ON_EN_CHANGE(IDC_VLC, OnEnChange)
	ON_BN_CLICKED(IDC_SELINCDIR, OnBnClickedSelincdir)
	ON_BN_CLICKED(IDC_SELTEMPDIR, OnBnClickedSeltempdir)
	ON_BN_CLICKED(IDC_SELVLC, OnBnClickedSelvlc)
	ON_BN_CLICKED(IDC_VIDEOBACKUP, OnEnChange)
	ON_BN_CLICKED(IDC_PREVIEW_SMALL, OnEnChange)
END_MESSAGE_MAP()

BOOL CPPgDirectories::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	incFilesEdit.SetLimitText(MAX_PATH);
	tempFilesEdit.SetLimitText(MAX_PATH);
	vlcEdit.SetLimitText(MAX_PATH);
	
	AddBuddy(incFilesEdit.m_hWnd, selIncDirButton.m_hWnd, BDS_RIGHT);
	AddBuddy(tempFilesEdit.m_hWnd, selTempDirButton.m_hWnd, BDS_RIGHT);
	AddBuddy(vlcEdit.m_hWnd, selVlcButton.m_hWnd, BDS_RIGHT);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgDirectories::LoadSettings(void)
{
	incFiles = m_pPrefs->GetIncomingDir();
	tempFiles = m_pPrefs->GetTempDir();
	vlc = m_pPrefs->GetVideoPlayer();

	m_ShareSelector.m_lstShared.RemoveAll();
	m_pPrefs->SharedDirListCopy(&m_ShareSelector.m_lstShared);
	m_ShareSelector.Init();

	m_TempSelector.m_lstShared.RemoveAll();
	m_pPrefs->TempDirListCopy(&m_TempSelector.m_lstShared);
	m_TempSelector.Init(false);	// disable CD-ROM drives as temp. location

	videoBackup = m_pPrefs->BackupPreview();
	smallBlocks = m_pPrefs->GetPreviewSmallBlocks();
	UpdateData(FALSE);
	SetModified(FALSE);
}

int CPPgDirectories::BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	if (uMsg == BFFM_INITIALIZED)
	{
		::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
	}

	return 0;
}

bool CPPgDirectories::SelectDir(const TCHAR* indir, TCHAR* outdir, const CString& titletext)
{
	CoInitialize(0);	
	TCHAR buffer[MAX_PATH];
	BROWSEINFO bi = { GetSafeHwnd(), 0, buffer, titletext, BIF_VALIDATE | BIF_NEWDIALOGSTYLE | BIF_RETURNONLYFSDIRS, BrowseCallbackProc, (LPARAM)indir, 0};
	LPITEMIDLIST pidl = SHBrowseForFolder(&bi);	
	bool done = SHGetPathFromIDList(pidl,outdir);
	LPMALLOC ppMalloc;
	if(SHGetMalloc(&ppMalloc) == NOERROR)
	{
		ppMalloc->Free(pidl);
		ppMalloc->Release();
	}
	CoUninitialize();
	return done;
}

void CPPgDirectories::OnBnClickedSelincdir()
{
	TCHAR buffer[MAX_PATH];
	if(SelectDir(incFiles, buffer, GetResString(IDS_SELECT_INCOMINGDIR))) {
		incFiles = buffer;
		UpdateData(FALSE);
		SetModified();
	}
}

void CPPgDirectories::OnBnClickedSeltempdir()
{
	TCHAR buffer[MAX_PATH];
	if(SelectDir(tempFiles, buffer, GetResString(IDS_SELECT_TEMPDIR))) {
		tempFiles = buffer;
		UpdateData(FALSE);
		SetModified();
	}
}

void CPPgDirectories::OnBnClickedSelvlc()
{
	CFileDialog dlgFile(TRUE, _T("*.exe"), NULL,OFN_FILEMUSTEXIST | OFN_NOREADONLYRETURN ,_T("Program (*.exe)|*.exe||"));
	dlgFile.m_pOFN->lpstrInitialDir = GetPathToFile(m_pPrefs->GetVideoPlayer());
	
	if (dlgFile.DoModal() == IDOK) {
		vlc = dlgFile.GetPathName();
		UpdateData(FALSE);
		SetModified();
	}
}

BOOL CPPgDirectories::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		if (!incFiles.IsEmpty())
		{
			m_pPrefs->SetIncomingDir(incFiles);
		}

		if (!tempFiles.IsEmpty())
		{
			m_pPrefs->SetTempDir(tempFiles);
		}

		m_pPrefs->SetVideoPlayer(vlc);
		m_pPrefs->SetBackupPreview(videoBackup);
		m_pPrefs->SetPreviewSmallBlocks(smallBlocks);

		if (m_bSharedDirsModified)
		{
			POSITION pos, pos1;	

			for (pos = m_ShareSelector.m_lstShared.GetHeadPosition(); (pos1 = pos) != NULL; )
			{
				if (!m_pPrefs->IsShareableDirectory(m_ShareSelector.m_lstShared.GetNext(pos)))
					m_ShareSelector.m_lstShared.RemoveAt(pos1);
			}
			m_pPrefs->SharedDirListRefill(&m_ShareSelector.m_lstShared);
			g_eMuleApp.m_pSharedFilesList->Reload();
		}

	//	Remove main temporary directory from the list if user added it
		POSITION pos, pos1;
		CString	strMainTemp = m_pPrefs->GetTempDir();

		strMainTemp += _T('\\');

		for (pos = m_TempSelector.m_lstShared.GetHeadPosition(); (pos1 = pos) != NULL; )
		{
			if (m_TempSelector.m_lstShared.GetNext(pos).CompareNoCase(strMainTemp) == 0)
			{
				m_TempSelector.m_lstShared.RemoveAt(pos1);
				break;
			}
		}
		m_pPrefs->TempDirListRefill(&m_TempSelector.m_lstShared);

		SetModified(FALSE);
		m_bSharedDirsModified = false;
	}
	return CPropertyPage::OnApply();
}

BOOL CPPgDirectories::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if(wParam == DIRLIST_ITEMSTATECHANGED)
	{
		if(lParam == (long)m_ShareSelector.m_hWnd)
			CheckSharedChanges();
		else if(lParam == (long)m_TempSelector.m_hWnd)
			CheckTempChanges();
	}
	return CPropertyPage::OnCommand(wParam, lParam);
}

void CPPgDirectories::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_DIR));

		GetResString(&incomingDesc, IDS_PW_INCOMING);
		GetResString(&tempDesc, IDS_PW_TEMP);
		GetResString(&vlcDesc, IDS_PW_VLC);
		GetResString(&sharedDesc, IDS_PW_SHARED);
		GetResString(&tempDirDesc, IDS_PW_TEMPDIR);
		videoBackupCheck.SetWindowText(GetResString(IDS_VIDEOBACKUP));
		smallBlocksCheck.SetWindowText(GetResString(IDS_PREVIEW_SMALL));

		UpdateData(FALSE);
	}
}

void CPPgDirectories::CheckSharedChanges(void)
{
	if (m_pPrefs->SharedDirListCmp(&m_ShareSelector.m_lstShared))
	{
		SetModified();
		m_bSharedDirsModified = true;
	}
}

void CPPgDirectories::CheckTempChanges(void)
{
	if (m_pPrefs->TempDirListCmp(&m_TempSelector.m_lstShared))
		SetModified();
}
